#include <file.au3>

;     
If WinExists(@ScriptName) Then Exit
AutoItWinSetTitle(@ScriptName)

;  
HotKeySet("{F4}", "SaveToFile")
HotKeySet("{F9}", "SaveFileDialog")

;     
Global $DestinationDir = "C:\Downloads"
;  
Global Const $cFileExtension = ".txt"
;  : 1 -  ; 2 -  
Global Const $cMode = 1
; -     
Global COnst $cFileNameLen = 10
;   
Global Const $cForbiddenCharsPattern = "(?i)[\\/\x01-\x1F:*?<>|""]"
; ,         (  )
Global Const $cReplaceChar = "_"
;         (   ,    ,   $cFileExtension - ".txt")
Global Const $cCheckAndAppendExtension = True
;       
Global Const $cClearClip = False
; ,    -         
Global Const $cMsgOnEmptyClip = True
;     , 
Global Const $cMsgTimeout = 5

; -----------------------------------------
;    () -              
; -----------------------------------------
While 1
	Sleep(100)
Wend


; -----------------------------------------
; 
; -----------------------------------------
Func SaveToFile()
	;     
	$Data = ClipGet()

	;         
	If $Data <> "" Then
		;  
		$DestinationFile = $DestinationDir & '\' & StringRegExpReplace(StringLeft($Data, $cFileNameLen), $cForbiddenCharsPattern, $cReplaceChar) & $cFileExtension
		;    ,    - 
		If Not FileExists($DestinationDir) Then DirCreate($DestinationDir)
		;    
		If _WriteTextToFile($DestinationFile, $Data, $cMode) <> 1 Then
			MsgBox(4096+16,'Error','Unable to write data to ' & $DestinationFile & ' file!',$cMsgTimeout)
		Else
			If $cClearClip Then
				ClipPut("")
			EndIf
		EndIf
	Else
		If $cMsgOnEmptyClip Then
			MsgBox(4096+48,'Warning','  !',$cMsgTimeout)
		EndIf
	EndIf
EndFunc

Func SaveFileDialog()
	;     
	$Data = ClipGet()

	;         
	If $Data <> "" Then
		;    ,    - 
		If Not FileExists($DestinationDir) Then DirCreate($DestinationDir)
		;    
		; 	:
		; 	2 = Path Must Exist (if user types a path, ending with a backslash)
		; 	16 = Prompt to OverWrite File
		$DestinationFile = FileSaveDialog( " ...", $DestinationDir, "  (*.txt)|All (*.*)", 2+16)
		If @error = 0 Then
			Dim $szDrive, $szDir, $szFName, $szExt
			$aPathParts = _PathSplit($DestinationFile, $szDrive, $szDir, $szFName, $szExt)

			If $cCheckAndAppendExtension Then
				If $szExt = "" Then
					$DestinationFile = $DestinationFile & $cFileExtension
				EndIf
			EndIf
			If _WriteTextToFile($DestinationFile, $Data, $cMode) <> 1 Then
				MsgBox(4096+16,'Error','Unable to write data to ' & $DestinationFile & ' file!',8)
			Else
				If $cClearClip Then
					ClipPut("")
				EndIf
			EndIf
		EndIf
	Else
		If $cMsgOnEmptyClip Then
			MsgBox(4096+48,'Warning','  !',$cMsgTimeout)
		EndIf
	EndIf
EndFunc

Func _WriteTextToFile($sFilePath, $Text, $writemode) ;     
	Local $hOpenFile
	Local $hWriteFile
	
	$hOpenFile = FileOpen($sFilePath, $writemode)
	
	If $hOpenFile = -1 Then
		SetError(1)
		Return 0
	EndIf
	
	$hWriteFile = FileWrite($hOpenFile, $Text)
	
	If $hWriteFile = -1 Then
		SetError(2)
		Return 0
	EndIf
	
	FileClose($hOpenFile)
	Return 1
EndFunc
